// dividuums brainfuck interpreter 0.2
//
// ---------------------------------
//
// Copyright (c) 2000 Florian Wesch <fw@dividuum.de>. All Rights Reserved.     
//                                                                              
// Permission to use, copy, modify, and distribute this software                
// and its documentation for any purposes and without               
// fee is hereby granted provided that this copyright notice                    
// appears in all copies.                                                       
//                                                                              
// Of course, this soft is provided "as is" without express or implied          
// warranty of any kind.        
//
// -----------------------------

#ifndef BFINTER_H
#define BFINTER_H

#include <stdlib.h>

#define BFINTERVERSION "brainfuck interpreter 0.2"

// Fehlercodes
#define BF_SUCCESS 0
#define BF_UNMATCHEDOPEN 1
#define BF_UNMATCHEDCLOSE 2
#define BF_OUTPUTFULL 3
#define BF_INPUTEMPTY 4
#define BF_OVERFLOW 5
#define BF_UNDERFLOW 6
#define BF_UNKNOWNOPCODE 7
#define BF_NOTSUPPORTED 8

// Opcodes
#define BF_OPINCV '+'
#define BF_OPLOOPS '['
#define BF_OPDECV '-'
#define BF_OPLOOPE ']'
#define BF_OPINCP '>'
#define BF_OPDECP '<'
#define BF_OPOUT '.'
#define BF_OPIN ','

int executebf(unsigned char *programm,  int progsize, 
              unsigned char *input,     int inputsize, 
              unsigned char *output,    int *outputsize, 
              int maxoutputsize,        int memsize);

#endif
